#include <amxmodx>
#include <fvault>

#define PLUGIN "Warning System"
#define VERSION "1.2"
#define AUTHOR "Biscuit"


#define ADMIN_FLAG ADMIN_BAN

new const g_vault_name[] = "UserWarningDate";

new warning[33]
new warning_id[33]
new gmsgFade
new warningmax
new warningsave

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	gmsgFade = get_user_msgid("ScreenFade")
	
	//Cvar
	warningmax = register_cvar("warning_max","3")
	warningsave = register_cvar("warning_save","1")

	//Command
	register_clcmd("warning_menu","WarningMenu")
	register_clcmd("_warning_reason","putinreason")
	
	//ML
	register_dictionary("warning_system.txt")

}


public client_connect(id) warning[id] = 0

public client_putinserver(id)
{
	if( get_pcvar_num(warningsave) && !is_user_hltv(id) && !is_user_bot(id) )
	{
		LoadData(id);
	}
}

public client_disconnect(id)
{
	if( get_pcvar_num(warningsave) && !is_user_hltv(id) && !is_user_bot(id) )
	{
		SaveData(id)
	}
}

public WarningMenu(id)
{
	if(get_user_flags(id) & ADMIN_FLAG)
	{
		new menu = menu_create("\rWarning Menu:", "Warningmenu_handler");

		new players[32], pnum, tempid;

		new szName[32], szTempid[10],namewithwarn[40]

		get_players(players, pnum,"ch");
		for( new i; i<pnum; i++ )
		{
			//Save a tempid so we do not re-index
			tempid = players[i];

			if(!(get_user_flags(tempid) & ADMIN_FLAG) && tempid != id && is_user_connected(tempid))
			{
				//Get the players name and id as strings
				get_user_name(tempid, szName, 31);
				
				if(warning[tempid] < 1)
					formatex(namewithwarn,39,"%s \y[\d%d\y/%d]",szName,warning[tempid],get_pcvar_num(warningmax))
				else
					formatex(namewithwarn,39,"%s \y[\r%d\y/%d]",szName,warning[tempid],get_pcvar_num(warningmax))
					
				num_to_str(tempid, szTempid, 9);

				//Add the item for this player
				menu_additem(menu, namewithwarn, szTempid, 0);
			}

		}
		menu_setprop(menu,MPROP_BACKNAME,"BACK")
		menu_setprop(menu,MPROP_NEXTNAME,"NEXT")
		menu_setprop(menu,MPROP_EXITNAME,"EXIT")

		//We now have all players in the menu, lets display the menu
		menu_display(id, menu, 0);
	}
	return PLUGIN_HANDLED
}

public Warningmenu_handler(id, menu, item)
{
	if( item == MENU_EXIT )
	{
		menu_destroy(menu);
		return PLUGIN_HANDLED;
	}

	new data[6], iName[64];
	new access, callback;
	menu_item_getinfo(menu, item, access, data,5, iName, 63, callback);

	//Get the id of the player that was selected
	warning_id[id] = str_to_num(data);

	//If the player is alive
	if( is_user_connected(warning_id[id]))
		ReasonMenu(id)

		
	menu_destroy(menu);
	return PLUGIN_HANDLED;
}

public ReasonMenu(admin)
 {
 	static szName[33]
	get_user_name(warning_id[admin],szName,32)
	new msg[64]
	formatex(msg,99,"\r %L: \y%s",admin,"WarningPlayer",szName)
	new menu = menu_create(msg, "Reasonmenu_handler");

	new reason[6][64],other[64]
	formatex(reason[1],63,"\w %L",admin,"REASON1")
	formatex(reason[2],63,"\w %L",admin,"REASON2")
	formatex(reason[3],63,"\w %L",admin,"REASON3")
	formatex(reason[4],63,"\w %L",admin,"REASON4")
	formatex(reason[5],63,"\w %L",admin,"REASON5")
	formatex(other,63,"\w %L",admin,"OTHER")
	
	menu_additem(menu, reason[1], "1", 0)
	menu_additem(menu, reason[2],"2",0)
	menu_additem(menu, reason[3], "3", 0)
	menu_additem(menu, reason[4], "4", 0)
	menu_additem(menu, reason[5], "5", 0)
	menu_additem(menu, other, "6", 0)
	
	menu_setprop(menu,MPROP_EXITNAME,"EXIT")

	//We now have all players in the menu, lets display the menu
	menu_display(admin, menu, 0);
}

public Reasonmenu_handler(admin, menu, item)
{
	if( item == MENU_EXIT )
	{
		menu_destroy(menu);
		return PLUGIN_HANDLED;
	}

	new data[6], iName[64];
	new access, callback;
	menu_item_getinfo(menu, item, access, data,5, iName, 63, callback);

	new player = warning_id[admin]
	new key = str_to_num(data);

	switch(key)
	{
		case 1:	client_print(player,print_center,"%L:%L ; %L",player,"WARNING",player,"REASON1",player,"MSG",warning[player],get_pcvar_num(warningmax))
		case 2: client_print(player,print_center,"%L:%L ; %L",player,"WARNING",player,"REASON2",player,"MSG",warning[player],get_pcvar_num(warningmax))
		case 3:	client_print(player,print_center,"%L:%L ; %L",player,"WARNING",player,"REASON3",player,"MSG",warning[player],get_pcvar_num(warningmax))
		case 4: client_print(player,print_center,"%L:%L ; %L",player,"WARNING",player,"REASON4",player,"MSG",warning[player],get_pcvar_num(warningmax))
		case 5:	client_print(player,print_center,"%L:%L ; %L",player,"WARNING",player,"REASON5",player,"MSG",warning[player],get_pcvar_num(warningmax))
		case 6:
		{
			client_cmd(admin,"messagemode _warning_reason")
			return PLUGIN_CONTINUE
		}
	}
	
	tell_player_he_get_warning(player)
		
	menu_destroy(menu);
	return PLUGIN_HANDLED;
}

public putinreason(admin)
{
	if(get_user_flags(admin) & ADMIN_FLAG)
	{
		static reason[64]
		read_args(reason, 63)
		remove_quotes(reason)
		
		if(reason[0])
		{
			new player = warning_id[admin]
			client_print(player,print_center,"%L:%s ; %L",player,"WARNING",reason,player,"MSG",warning[player],get_pcvar_num(warningmax))
			tell_player_he_get_warning(player)
		}
		else
			client_print(admin,print_chat,"[Warning System] %L",admin,"NoReason")	
	}
	return PLUGIN_HANDLED
}

public tell_player_he_get_warning(player)
{
	warning[player]++
	client_cmd(player,"spk fvox/warning")
	
	
	message_begin(MSG_ONE, gmsgFade, {0,0,0}, player)
	write_short(1<<12) // fade lasts this long duration  
	write_short(1<<12) // fade lasts this long hold time  
	write_short(0<<1) // fade type OUT 
	write_byte(255) // fade red  
	write_byte(0) // fade green  
	write_byte(0) // fade blue    
	write_byte(255) // fade alpha   
	message_end()
	
	if(warning[player] >= get_pcvar_num(warningmax))
		server_cmd("amx_ban #%d 0",get_user_userid(player))
}

LoadData(id)
{
	static authid[33];
	get_user_authid(id, authid, 32);
    
	new SaveWarning[3];
	if( fvault_get_data(g_vault_name, authid,  SaveWarning, 2) )
		warning[id] = str_to_num(SaveWarning)
}

SaveData(id)
{
	static authid[33];
	get_user_authid(id, authid, 32);
    
	new SaveWarning[3];
	num_to_str(warning[id], SaveWarning,2)
	if(0 < warning[id] < get_pcvar_num(warningmax))
		fvault_set_data(g_vault_name, authid, SaveWarning);
	else
		fvault_remove_key(g_vault_name, authid)
}